Attribute VB_Name = "Settings"
Option Explicit

Sub gSetMainFormPosition(frmMain As Form)
Dim lReturn As Long
Dim hlstrWindowState As String
Dim hlstrTopPosition As String
Dim lTopPosition As Long
Dim hlstrLeftPosition As String
Dim lLeftPosition As Long
Dim hlstrFormWidth As String
Dim lFormWidth As Long
Dim hlstrFormHeight As String
Dim lFormHeight As Long
Dim hWndWindowState As Long
Dim lpcbData As Long

  lpcbData = 255

  lReturn = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Que\MainForm", 0&, KEY_ALL_ACCESS, hWndWindowState)
  If lReturn = 2 Then
    hlstrWindowState = ""
  Else
    hlstrWindowState = Space$(lpcbData)
    lReturn = RegQueryValueEx(hWndWindowState, "WindowState", 0&, REG_SZ, hlstrWindowState, lpcbData)
    If lReturn <> ERROR_SUCCESS Then
      gAPIDisplayError lReturn
      Exit Sub
    End If
  End If
  
  Select Case Val(hlstrWindowState)
    Case 0
      lpcbData = 255
      hlstrTopPosition = Space$(lpcbData)
      lReturn = RegQueryValueEx(hWndWindowState, "TopPosition", 0&, REG_SZ, hlstrTopPosition, lpcbData)
      lTopPosition = Val(hlstrTopPosition)
      
      lpcbData = 255
      hlstrLeftPosition = Space$(lpcbData)
      lReturn = RegQueryValueEx(hWndWindowState, "LeftPosition", 0&, REG_SZ, hlstrLeftPosition, lpcbData)
      lLeftPosition = Val(hlstrLeftPosition)
      
      lpcbData = 255
      hlstrFormWidth = Space$(lpcbData)
      lReturn = RegQueryValueEx(hWndWindowState, "FormWidth", 0&, REG_SZ, hlstrFormWidth, lpcbData)
      lFormWidth = Val(hlstrFormWidth)
      
      lpcbData = 255
      hlstrFormHeight = Space$(lpcbData)
      lReturn = RegQueryValueEx(hWndWindowState, "FormHeight", 0&, REG_SZ, hlstrFormHeight, lpcbData)
      lFormHeight = Val(hlstrFormHeight)
      
      frmMain.Move lLeftPosition, lTopPosition, lFormWidth, lFormHeight
    Case 1
      frmMain.WindowState = vbMinimized
    Case 2
      frmMain.WindowState = vbMaximized
    Case Else
      frmMain.Width = 640 * Screen.TwipsPerPixelX
      frmMain.Height = 480 * Screen.TwipsPerPixelY
      If frmMain.Width + 100 > Screen.Width Then
        frmMain.WindowState = vbMaximized
      Else
        frmMain.Top = (Screen.Height - frmMain.Height) \ 2
        frmMain.Left = (Screen.Width - frmMain.Width) \ 2
      End If
  End Select

  lReturn = RegCloseKey(hWndWindowState)

End Sub


Sub gSaveMainFormPosition(frmMain As Form)
Dim hWndQue As Long
Dim hlstrWindowState As String
Dim hlstrTopPosition As String
Dim hlstrLeftPosition As String
Dim hlstrFormWidth As String
Dim hlstrFormHeight As String
Dim lpClass As String
Dim Security As SECURITY_ATTRIBUTES
Dim lpdwDisposition As Long
Dim lReturn As Long

  lpClass = Space$(255)
  lReturn = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "Que\MainForm", 0&, lpClass, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, Security, hWndQue, lpdwDisposition)
  If lReturn <> ERROR_SUCCESS Then
    gAPIDisplayError lReturn
  End If

  hlstrWindowState = Trim$(Str$(frmMain.WindowState))
  lReturn = RegSetValueEx(hWndQue, "WindowState", 0&, REG_SZ, hlstrWindowState, Len(hlstrWindowState))
  If lReturn <> ERROR_SUCCESS Then
    gAPIDisplayError lReturn
  End If

  hlstrTopPosition = Trim$(Str$(frmMain.Top))
  lReturn = RegSetValueEx(hWndQue, "TopPosition", 0&, REG_SZ, hlstrTopPosition, Len(hlstrTopPosition))
  If lReturn <> ERROR_SUCCESS Then
    gAPIDisplayError lReturn
  End If

  hlstrLeftPosition = Trim$(Str$(frmMain.Left))
  lReturn = RegSetValueEx(hWndQue, "LeftPosition", 0&, REG_SZ, hlstrLeftPosition, Len(hlstrLeftPosition))
  If lReturn <> ERROR_SUCCESS Then
    gAPIDisplayError lReturn
  End If
  
  hlstrFormWidth = Trim$(Str$(frmMain.Width))
  lReturn = RegSetValueEx(hWndQue, "FormWidth", 0&, REG_SZ, hlstrFormWidth, Len(hlstrFormWidth))
  If lReturn <> ERROR_SUCCESS Then
    gAPIDisplayError lReturn
  End If
  
  hlstrFormHeight = Trim$(Str$(frmMain.Height))
  lReturn = RegSetValueEx(hWndQue, "FormHeight", 0&, REG_SZ, hlstrFormHeight, Len(hlstrFormHeight))
  If lReturn <> ERROR_SUCCESS Then
    gAPIDisplayError lReturn
  End If
  
  lReturn = RegCloseKey(hWndQue)

End Sub


